'use strict';
const Generator = require('yeoman-generator');
const chalk = require('chalk');
const yosay = require('yosay');
const fss = require('fs');
module.exports = class extends Generator {
  opt = "";
  tipo = "";
  name = "";
  constructor(args, opts) {
    super(args, opts);
    if (args.length == 3) {
      switch (args[0]) {
        case "g":
        case "generate":
          this.opt = "g"
          break;
      }
      switch (args[1]) {
        case "c":
        case "component":
          this.tipo = "c";
          break;
      }
      this.name = args[2];
    }
  }

  prompting() {
    if (this.opt == "" || this.tipo == "") {
      console.log("Opciones erroneas.");
      return;
    }
  }

  writing() {
    fss.mkdirSync(this.name);
    this.fs.copyTpl(
      this.templatePath("topbar.jsx"),
      this.destinationPath(`${this.name}/${this.name}.jsx`),
      {
        appName: this.name,
        className: this.capitalizeFirstLetter(this.name)
      }
    );
    this.fs.copy(
      this.templatePath("topbar.css"),
      this.destinationPath(`${this.name}/${this.name}.css`),
    );
    this.log(
      yosay(
        `Componente ${chalk.red(this.name)} generado!`
      )
    );
  }

  capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1).toLowerCase();
  }

};
